/* vinagre-utils.c generated by valac 0.12.1, the Vala compiler
 * generated from vinagre-utils.vala, do not modify */

/*  Vinagre - GNOME Remote Desktop viewer
 *
 *  Copyright (C) 2011  David King <amigadave@amigadave.com>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <config.h>
#include <gdk/gdk.h>

typedef struct _Block1Data Block1Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;

struct _Block1Data {
	int _ref_count_;
	GtkMessageDialog* dialog;
};

struct _Block2Data {
	int _ref_count_;
	gchar* messages;
};

struct _Block3Data {
	int _ref_count_;
	GtkButton* ok_button;
	GtkEntry* username_entry;
	GtkEntry* password_entry;
};



gboolean vinagre_utils_parse_boolean (const gchar* str);
void vinagre_utils_set_widget_visible (GtkWidget* widget, gboolean visible);
void vinagre_utils_show_error_dialog (const gchar* title, const gchar* message, GtkWindow* parent);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (Block1Data* _data1_);
static void _lambda0_ (GtkDialog* d, gint response, Block1Data* _data1_);
static void __lambda0__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self);
void vinagre_utils_show_many_errors (const gchar* title, GSList* items, GtkWindow* parent);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (Block2Data* _data2_);
static void _lambda1_ (const gchar* message, Block2Data* _data2_);
static void __lambda1__gfunc (gconstpointer data, gpointer self);
gboolean vinagre_utils_create_dir_for_file (const gchar* filename, GError** error);
GtkBuilder* vinagre_utils_get_builder (void);
gchar* vinagre_dirs_get_package_data_file (const gchar* filename);
gboolean vinagre_utils_request_credential (GtkWindow* parent, const gchar* protocol, const gchar* host, gboolean need_username, gboolean need_password, gint password_limit, gchar** username, gchar** password, gboolean* save_in_keyring);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (Block3Data* _data3_);
static void _lambda2_ (Block3Data* _data3_);
static void __lambda2__gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void _lambda3_ (Block3Data* _data3_);
static void __lambda3__gtk_editable_changed (GtkEditable* _sender, gpointer self);
void vinagre_utils_show_help (GtkWindow* window, const gchar* page);
void vinagre_utils_show_help_about (GtkWindow* parent);


gboolean vinagre_utils_parse_boolean (const gchar* str) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (str != NULL, FALSE);
	if (g_strcmp0 (str, "true") == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (str, "1") == 0;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}


void vinagre_utils_set_widget_visible (GtkWidget* widget, gboolean visible) {
	g_return_if_fail (widget != NULL);
	if (visible) {
		gtk_widget_show_all (widget);
	} else {
		gtk_widget_hide (widget);
	}
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (Block1Data* _data1_) {
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_object_unref0 (_data1_->dialog);
		g_slice_free (Block1Data, _data1_);
	}
}


static void _lambda0_ (GtkDialog* d, gint response, Block1Data* _data1_) {
	g_return_if_fail (d != NULL);
	gtk_widget_destroy ((GtkWidget*) _data1_->dialog);
}


static void __lambda0__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self) {
	_lambda0_ (_sender, response_id, self);
}


void vinagre_utils_show_error_dialog (const gchar* title, const gchar* message, GtkWindow* parent) {
	Block1Data* _data1_;
	GtkMessageDialog* _tmp1_ = NULL;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	if (title != NULL) {
		const gchar* _tmp0_ = NULL;
		_tmp0_ = _ ("An error occurred");
		title = _tmp0_;
	}
	_tmp1_ = (GtkMessageDialog*) gtk_message_dialog_new (parent, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "%s", title);
	_data1_->dialog = g_object_ref_sink (_tmp1_);
	if (message != NULL) {
		gtk_message_dialog_format_secondary_markup (_data1_->dialog, "%s", message, NULL);
	}
	g_signal_connect_data ((GtkDialog*) _data1_->dialog, "response", (GCallback) __lambda0__gtk_dialog_response, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	gtk_widget_show_all ((GtkWidget*) _data1_->dialog);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (Block2Data* _data2_) {
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		_g_free0 (_data2_->messages);
		g_slice_free (Block2Data, _data2_);
	}
}


static void _lambda1_ (const gchar* message, Block2Data* _data2_) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_if_fail (message != NULL);
	_tmp0_ = g_strdup_printf (_data2_->messages, "%s\n", message);
	_tmp1_ = _tmp0_;
	_g_free0 (_tmp1_);
}


static void __lambda1__gfunc (gconstpointer data, gpointer self) {
	_lambda1_ (data, self);
}


void vinagre_utils_show_many_errors (const gchar* title, GSList* items, GtkWindow* parent) {
	Block2Data* _data2_;
	gchar* _tmp0_;
	g_return_if_fail (parent != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_tmp0_ = g_strdup ("");
	_data2_->messages = _tmp0_;
	g_slist_foreach (items, __lambda1__gfunc, _data2_);
	vinagre_utils_show_error_dialog (title, _data2_->messages, parent);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}


gboolean vinagre_utils_create_dir_for_file (const gchar* filename, GError** error) {
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	GFile* file;
	GFile* _tmp1_ = NULL;
	GFile* parent;
	gchar* _tmp2_ = NULL;
	gchar* parent_path;
	gboolean _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (filename != NULL, FALSE);
	_tmp0_ = g_file_new_for_path (filename);
	file = _tmp0_;
	_tmp1_ = g_file_get_parent (file);
	parent = _tmp1_;
	_tmp2_ = g_file_get_path (parent);
	parent_path = _tmp2_;
	_tmp3_ = g_file_test (parent_path, G_FILE_TEST_EXISTS);
	if (!_tmp3_) {
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = g_file_make_directory_with_parents (parent, NULL, &_inner_error_);
		_tmp5_ = _tmp4_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (parent_path);
			_g_object_unref0 (parent);
			_g_object_unref0 (file);
			return FALSE;
		}
		result = _tmp5_;
		_g_free0 (parent_path);
		_g_object_unref0 (parent);
		_g_object_unref0 (file);
		return result;
	} else {
		result = TRUE;
		_g_free0 (parent_path);
		_g_object_unref0 (parent);
		_g_object_unref0 (file);
		return result;
	}
	_g_free0 (parent_path);
	_g_object_unref0 (parent);
	_g_object_unref0 (file);
}


GtkBuilder* vinagre_utils_get_builder (void) {
	GtkBuilder* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* filename;
	GtkBuilder* _tmp1_ = NULL;
	GtkBuilder* builder;
	GError * _inner_error_ = NULL;
	_tmp0_ = vinagre_dirs_get_package_data_file ("vinagre.ui");
	filename = _tmp0_;
	_tmp1_ = gtk_builder_new ();
	builder = _tmp1_;
	gtk_builder_add_from_file (builder, filename, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch0_g_error;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * err;
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		gchar* subtitle;
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* closing;
		gchar* _tmp6_ = NULL;
		gchar* message;
		const gchar* _tmp7_ = NULL;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = _ ("Vinagre failed to open a UI file," " with the error message:");
		_tmp3_ = g_strdup (_tmp2_);
		subtitle = _tmp3_;
		_tmp4_ = _ ("Please check your installation.");
		_tmp5_ = g_strdup (_tmp4_);
		closing = _tmp5_;
		_tmp6_ = g_strdup_printf ("%s\n\n%s\n\n%s", subtitle, err->message, closing);
		message = _tmp6_;
		_tmp7_ = _ ("Error loading UI file");
		vinagre_utils_show_error_dialog (_tmp7_, message, NULL);
		_g_free0 (message);
		_g_free0 (closing);
		_g_free0 (subtitle);
		_g_error_free0 (err);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (builder);
		_g_free0 (filename);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = builder;
	_g_free0 (filename);
	return result;
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void block3_data_unref (Block3Data* _data3_) {
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		_g_object_unref0 (_data3_->password_entry);
		_g_object_unref0 (_data3_->username_entry);
		_g_object_unref0 (_data3_->ok_button);
		g_slice_free (Block3Data, _data3_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _lambda2_ (Block3Data* _data3_) {
	gboolean enabled;
	gboolean _tmp0_;
	gboolean _tmp3_;
	enabled = TRUE;
	_tmp0_ = gtk_widget_get_visible ((GtkWidget*) _data3_->username_entry);
	if (_tmp0_) {
		gboolean _tmp1_ = FALSE;
		if (enabled) {
			guint _tmp2_;
			_tmp2_ = gtk_entry_get_text_length (_data3_->username_entry);
			_tmp1_ = _tmp2_ > 0;
		} else {
			_tmp1_ = FALSE;
		}
		enabled = _tmp1_;
	}
	_tmp3_ = gtk_widget_get_visible ((GtkWidget*) _data3_->password_entry);
	if (_tmp3_) {
		gboolean _tmp4_ = FALSE;
		if (enabled) {
			guint _tmp5_;
			_tmp5_ = gtk_entry_get_text_length (_data3_->password_entry);
			_tmp4_ = _tmp5_ > 0;
		} else {
			_tmp4_ = FALSE;
		}
		enabled = _tmp4_;
	}
	gtk_widget_set_sensitive ((GtkWidget*) _data3_->ok_button, enabled);
}


static void __lambda2__gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	_lambda2_ (self);
}


static void _lambda3_ (Block3Data* _data3_) {
	gboolean enabled;
	gboolean _tmp0_;
	gboolean _tmp3_;
	enabled = TRUE;
	_tmp0_ = gtk_widget_get_visible ((GtkWidget*) _data3_->username_entry);
	if (_tmp0_) {
		gboolean _tmp1_ = FALSE;
		if (enabled) {
			guint _tmp2_;
			_tmp2_ = gtk_entry_get_text_length (_data3_->username_entry);
			_tmp1_ = _tmp2_ > 0;
		} else {
			_tmp1_ = FALSE;
		}
		enabled = _tmp1_;
	}
	_tmp3_ = gtk_widget_get_visible ((GtkWidget*) _data3_->password_entry);
	if (_tmp3_) {
		gboolean _tmp4_ = FALSE;
		if (enabled) {
			guint _tmp5_;
			_tmp5_ = gtk_entry_get_text_length (_data3_->password_entry);
			_tmp4_ = _tmp5_ > 0;
		} else {
			_tmp4_ = FALSE;
		}
		enabled = _tmp4_;
	}
	gtk_widget_set_sensitive ((GtkWidget*) _data3_->ok_button, enabled);
}


static void __lambda3__gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	_lambda3_ (self);
}


gboolean vinagre_utils_request_credential (GtkWindow* parent, const gchar* protocol, const gchar* host, gboolean need_username, gboolean need_password, gint password_limit, gchar** username, gchar** password, gboolean* save_in_keyring) {
	gchar* _username = NULL;
	gchar* _password = NULL;
	gboolean _save_in_keyring = FALSE;
	gboolean result = FALSE;
	Block3Data* _data3_;
	GtkBuilder* _tmp0_ = NULL;
	GtkBuilder* xml;
	GObject* _tmp1_ = NULL;
	GObject* _tmp2_;
	GtkDialog* _tmp3_;
	GtkDialog* password_dialog;
	GObject* _tmp4_ = NULL;
	GObject* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* auth_label;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	GObject* _tmp10_ = NULL;
	GObject* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* host_label;
	GObject* _tmp13_ = NULL;
	GObject* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* password_label;
	GObject* _tmp16_ = NULL;
	GObject* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* username_label;
	GObject* _tmp19_ = NULL;
	GObject* _tmp20_;
	GtkCheckButton* _tmp21_;
	GtkCheckButton* save_credential_check;
	GObject* _tmp22_ = NULL;
	GObject* _tmp23_;
	GtkButton* _tmp24_;
	GtkImage* _tmp25_ = NULL;
	GtkImage* image;
	GObject* _tmp26_ = NULL;
	GObject* _tmp27_;
	GtkEntry* _tmp28_;
	GObject* _tmp29_ = NULL;
	GObject* _tmp30_;
	GtkEntry* _tmp31_;
	gint _tmp32_;
	gint _result_;
	g_return_val_if_fail (parent != NULL, FALSE);
	g_return_val_if_fail (protocol != NULL, FALSE);
	g_return_val_if_fail (host != NULL, FALSE);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_tmp0_ = vinagre_utils_get_builder ();
	xml = _tmp0_;
	_tmp1_ = gtk_builder_get_object (xml, "auth_required_dialog");
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (GTK_IS_DIALOG (_tmp2_) ? ((GtkDialog*) _tmp2_) : NULL);
	password_dialog = _tmp3_;
	gtk_window_set_transient_for ((GtkWindow*) password_dialog, parent);
	_tmp4_ = gtk_builder_get_object (xml, "auth_required_label");
	_tmp5_ = _tmp4_;
	_tmp6_ = _g_object_ref0 (GTK_IS_LABEL (_tmp5_) ? ((GtkLabel*) _tmp5_) : NULL);
	auth_label = _tmp6_;
	_tmp7_ = _ ("%s authentication is required");
	_tmp8_ = g_strdup_printf (_tmp7_, protocol);
	_tmp9_ = _tmp8_;
	gtk_label_set_label (auth_label, _tmp9_);
	_g_free0 (_tmp9_);
	_tmp10_ = gtk_builder_get_object (xml, "host_label");
	_tmp11_ = _tmp10_;
	_tmp12_ = _g_object_ref0 (GTK_IS_LABEL (_tmp11_) ? ((GtkLabel*) _tmp11_) : NULL);
	host_label = _tmp12_;
	gtk_label_set_label (host_label, host);
	_tmp13_ = gtk_builder_get_object (xml, "password_label");
	_tmp14_ = _tmp13_;
	_tmp15_ = _g_object_ref0 (GTK_IS_LABEL (_tmp14_) ? ((GtkLabel*) _tmp14_) : NULL);
	password_label = _tmp15_;
	_tmp16_ = gtk_builder_get_object (xml, "username_label");
	_tmp17_ = _tmp16_;
	_tmp18_ = _g_object_ref0 (GTK_IS_LABEL (_tmp17_) ? ((GtkLabel*) _tmp17_) : NULL);
	username_label = _tmp18_;
	_tmp19_ = gtk_builder_get_object (xml, "save_credential_check");
	_tmp20_ = _tmp19_;
	_tmp21_ = _g_object_ref0 (GTK_IS_CHECK_BUTTON (_tmp20_) ? ((GtkCheckButton*) _tmp20_) : NULL);
	save_credential_check = _tmp21_;
	_tmp22_ = gtk_builder_get_object (xml, "ok_button");
	_tmp23_ = _tmp22_;
	_tmp24_ = _g_object_ref0 (GTK_IS_BUTTON (_tmp23_) ? ((GtkButton*) _tmp23_) : NULL);
	_data3_->ok_button = _tmp24_;
	_tmp25_ = (GtkImage*) gtk_image_new_from_stock (GTK_STOCK_DIALOG_AUTHENTICATION, GTK_ICON_SIZE_DIALOG);
	image = g_object_ref_sink (_tmp25_);
	gtk_button_set_image (_data3_->ok_button, (GtkWidget*) image);
	_tmp26_ = gtk_builder_get_object (xml, "username_entry");
	_tmp27_ = _tmp26_;
	_tmp28_ = _g_object_ref0 (GTK_IS_ENTRY (_tmp27_) ? ((GtkEntry*) _tmp27_) : NULL);
	_data3_->username_entry = _tmp28_;
	_tmp29_ = gtk_builder_get_object (xml, "password_entry");
	_tmp30_ = _tmp29_;
	_tmp31_ = _g_object_ref0 (GTK_IS_ENTRY (_tmp30_) ? ((GtkEntry*) _tmp30_) : NULL);
	_data3_->password_entry = _tmp31_;
	g_signal_connect_data ((GtkEditable*) _data3_->username_entry, "changed", (GCallback) __lambda2__gtk_editable_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	if (!need_username) {
		gtk_widget_hide ((GtkWidget*) username_label);
		gtk_widget_hide ((GtkWidget*) _data3_->username_entry);
	}
	g_signal_connect_data ((GtkEditable*) _data3_->password_entry, "changed", (GCallback) __lambda3__gtk_editable_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	if (need_password) {
		gtk_entry_set_max_length (_data3_->password_entry, password_limit);
	} else {
		gtk_widget_hide ((GtkWidget*) password_label);
		gtk_widget_hide ((GtkWidget*) _data3_->password_entry);
	}
	_tmp32_ = gtk_dialog_run (password_dialog);
	_result_ = _tmp32_;
	if (_result_ == GTK_RESPONSE_OK) {
		guint _tmp33_;
		guint _tmp36_;
		_tmp33_ = gtk_entry_get_text_length (_data3_->username_entry);
		if (_tmp33_ > 0) {
			const gchar* _tmp34_ = NULL;
			gchar* _tmp35_;
			_tmp34_ = gtk_entry_get_text (_data3_->username_entry);
			_tmp35_ = g_strdup (_tmp34_);
			_g_free0 (_username);
			_username = _tmp35_;
		}
		_tmp36_ = gtk_entry_get_text_length (_data3_->password_entry);
		if (_tmp36_ > 0) {
			const gchar* _tmp37_ = NULL;
			gchar* _tmp38_;
			_tmp37_ = gtk_entry_get_text (_data3_->password_entry);
			_tmp38_ = g_strdup (_tmp37_);
			_g_free0 (_password);
			_password = _tmp38_;
		}
		if (_save_in_keyring) {
			gboolean _tmp39_;
			_tmp39_ = gtk_toggle_button_get_active ((GtkToggleButton*) save_credential_check);
			_save_in_keyring = _tmp39_;
		}
	}
	gtk_widget_destroy ((GtkWidget*) password_dialog);
	result = _result_ == GTK_RESPONSE_OK;
	_g_object_unref0 (image);
	_g_object_unref0 (save_credential_check);
	_g_object_unref0 (username_label);
	_g_object_unref0 (password_label);
	_g_object_unref0 (host_label);
	_g_object_unref0 (auth_label);
	_g_object_unref0 (password_dialog);
	_g_object_unref0 (xml);
	block3_data_unref (_data3_);
	_data3_ = NULL;
	if (username) {
		*username = _username;
	} else {
		_g_free0 (_username);
	}
	if (password) {
		*password = _password;
	} else {
		_g_free0 (_password);
	}
	if (save_in_keyring) {
		*save_in_keyring = _save_in_keyring;
	}
	return result;
}


void vinagre_utils_show_help (GtkWindow* window, const gchar* page) {
	gchar* uri = NULL;
	GdkScreen* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (window != NULL);
	if (page != NULL) {
		gchar* _tmp0_;
		_tmp0_ = g_strconcat ("ghelp:" PACKAGE_TARNAME "?", page, NULL);
		_g_free0 (uri);
		uri = _tmp0_;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("ghelp:" PACKAGE_TARNAME);
		_g_free0 (uri);
		uri = _tmp1_;
	}
	_tmp2_ = gtk_window_get_screen (window);
	gtk_show_uri (_tmp2_, uri, (guint32) GDK_CURRENT_TIME, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch1_g_error;
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * _error_;
		const gchar* _tmp3_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = _ ("Error showing help");
		vinagre_utils_show_error_dialog (_tmp3_, _error_->message, window);
		_g_error_free0 (_error_);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_free0 (uri);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (uri);
}


void vinagre_utils_show_help_about (GtkWindow* parent) {
	GtkBuilder* _tmp0_ = NULL;
	GtkBuilder* builder;
	GObject* _tmp1_ = NULL;
	GObject* _tmp2_;
	GtkAboutDialog* _tmp3_;
	GtkAboutDialog* dialog;
	g_return_if_fail (parent != NULL);
	_tmp0_ = vinagre_utils_get_builder ();
	builder = _tmp0_;
	_tmp1_ = gtk_builder_get_object (builder, "about_dialog");
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (GTK_IS_ABOUT_DIALOG (_tmp2_) ? ((GtkAboutDialog*) _tmp2_) : NULL);
	dialog = _tmp3_;
	gtk_about_dialog_set_logo_icon_name (dialog, PACKAGE_TARNAME);
	gtk_about_dialog_set_version (dialog, PACKAGE_VERSION);
	gtk_about_dialog_set_website (dialog, PACKAGE_URL);
	gtk_window_set_transient_for ((GtkWindow*) dialog, parent);
	gtk_dialog_run ((GtkDialog*) dialog);
	gtk_widget_hide ((GtkWidget*) dialog);
	_g_object_unref0 (dialog);
	_g_object_unref0 (builder);
}



